# -*- coding: utf-8 -*-
#AdvancedSmileyPack.py
#Дополнительны смайлы

import re, os
import base

advpack1 = {
"page":"nafig",
"target":"advsmile",
"caption":u"Ушел нафиг",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [  u"ушёл нафиг", u"полетел", u"э..ты где тама", u"я поплыл", u"спокойной ночи" ]
    ]
}
advpack2 = {
"page":"sleep",
"target":"advsmile",
"caption":u"Kill-Sleep",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [],
        [],
        [ "blabla", "clever", "dream", "hot", "hm", "pleasant", "redbla", "love", "seeit", "what", "bigcry" ],
        [ "boxing", "kill", "sleep", "shoot" ]
    ]
}
advpack3 = {
"page":"drinking",
"target":"advsmile",
"caption":u"Drinking",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [ "reset", "drinking", u"бокс" ],
        [ u"киссс", u"киссссссс", "flowers1", "flowers2" ]
    ]
}
advpack4 = {
"page":"pom",
"target":"advsmile",
"caption":u"Помидор",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        ["ass", u"ангел", u"апчхи", u"в обмороке", u"любовь", u"молчу", u"ни-за-что!", u"оооо", u"покраснел"],
        [u"помидор", u"ррррр", u"сдаюсь", u"сплю", u"хай!", "sp578", "sp5277"]
    ]
}

advpack5 = {
"page":"whois",
"target":"advsmile",
"caption":u"Кто там",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [ "kto", "mail", "nail", "ura1" ],
        [ "bot", "fire", "gy", "wow" ]
    ]
}

advpack6 = {
"page":"old",
"target":"advsmile",
"caption":u"Old-Crazy",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [ "au", "crazy", "gun", "hul", "jok" ],
        [ "mob", "much", "nunu", "old", "pya" ]
    ]
}

advpack7 = {
"page":"bubu",
"target":"advsmile",
"caption":u"Бу-Бу",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [ "bubu", "dozor", "hook1", "kos" ]
    ]
}

advpack8 = {
"page":"velo",
"target":"advsmile",
"caption":u"Вело",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [ "velo", "wht", "zzz", "tooth", "thk" ],
        [ "str", "sla", "shy2", "kult", "sad", "unknw" ]
    ]
}

advpack9 = {
"page":"kettle",
"target":"advsmile",
"caption":u"Чайник",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [ "confsqr", "dyb", "elec", "grinz", "hug", "kettle", "mpr" ],
        [ "music", "rot", "str2", "wink2" ]
    ]
}

advpack10 = {
"page":"pooh",
"target":"advsmile",
"caption":u"Вини-Пух",
"path":"pixmaps/smileys/advanced/",
"prefix":"",
"smileys":[
        [],
        [],
        [ "pooh", "blink", "skull", "help", "wallbash", "wacko", "ph34r" ]
    ]
}
packs = [advpack1,advpack2,advpack3,advpack4,advpack5,advpack6,advpack7,advpack8,advpack9,advpack10]

class AdvancedSmileyPack(base.Baselugin):
    def __init__(self,parent,modulename,active):
        base.Baselugin.__init__(self,parent,modulename,active)
        self.name = "Advanced Smileys"
        self.version = "v1.0"
        self.description =u"""Большой пак дополнительных смайлов."""
        self.smilemanager = parent.SmileyManager
        self.SetActive(active)
        parent.Worker.parseImages = self.parseImages(parent.Worker.parseImages)


    def SetActive(self,active = True): #Тут тоже делаем чего-то..
        self.active = active
        if self.active:
            for pack in packs:
                self.smilemanager.AddPage(pack)
        else:
            for pack in packs:
                self.smilemanager.DeletePage(pack)

    def replaceAdvSmile(self, m):
        imgpath = "pixmaps/smileys/advanced/%s.gif" % m.group(2)
        if os.path.exists(imgpath):
            return '<glink href="%s" target="advsmile"><img src="%s"></glink>' % (m.group(2),imgpath)
        else:
            return ':(%s):' % m.group(2)

    def parseImages(self, parentparseImages):
        def wrapper(msg):
            if not self.active: return parentparseImages(msg)
            msg = re.sub('(?i)(:\((.+?)\):)', self.replaceAdvSmile, msg, 0)
            return parentparseImages(msg)
        return wrapper

